<?php

function createSettingFile($page_title, $file_name, $text_color, $back_color, $image_link, $image_number, $image_sort, $image_enlarge, $image_volume, $password){
$filePath = __DIR__ . '/setting.php';
$data = "<?php\n"
  . "define('PAGE_TITLE', '" . $page_title . "');\n"
  . "define('FILE_NAME', '" . $file_name . "');\n"
  . "define('TEXT_COLOR', '" . $text_color . "');\n"
  . "define('BACK_COLOR', '" . $back_color . "');\n"
  . "define('IMAGE_LINK', '" . $image_link . "');\n"
  . "define('IMAGE_NUMBER', '" . $image_number . "');\n"
  . "define('IMAGE_SORT', '" . $image_sort . "');\n"
  . "define('IMAGE_ENLARGE', '" . $image_enlarge . "');\n"
  . "define('IMAGE_VOLUME', '" . $image_volume . "');\n"
  . "define('PASSWORD', '" . $password . "');\n";
file_put_contents($filePath, $data, LOCK_EX);
}

/**
 * 画像を削除
 */
function delImage($filename) {
  global $upload_dir;
  global $masonry_dir;

  $delefile = $upload_dir . $filename . "*";
  foreach ( glob($delefile) as $val ) {
    unlink($val);
  }

  $delefile = $masonry_dir . $filename . "*";
  foreach ( glob($delefile) as $val ) {
    unlink($val);
  }
}

function thumnail($file_ext) {
  global $unixtime;
  global $upload_dir;
  global $masonry_dir;
//元画像ファイル
$file = $upload_dir . "img-" . $unixtime . "." . $file_ext;

//拡張子無し
$thum_filename = "img-" . $unixtime;

//元画像ファイルサイズ
// ファイル名にスペースが含まれる場合は適切にエンコードしてください
list($moto_w, $moto_h) = getimagesize($file);

//サムネイルサイズ
//$thum_w = 150;
//$thum_h = 150;
//500pxサイズ
$downsize_w = 500;
$downsize_h = round($downsize_w * $moto_h / $moto_w);
//オリジナルサイズ
$original_w = $moto_w;
$original_h = $moto_h;

if($moto_w > $downsize_w) {
$downsize_img = imagecreatetruecolor($downsize_w, $downsize_h);
} else {
$original_img = imagecreatetruecolor($original_w, $original_h);
}


//元画像の拡張子で判別して元画像データ作成
switch ($file_ext) {

	case 'jpg':
		$moto_img = imagecreatefromjpeg($file);
		break;

	case 'png':
		$moto_img = imagecreatefrompng($file);
		break;

	case 'gif':
		$moto_img = imagecreatefromgif($file);
		break;

	case 'webp':
		$moto_img = imagecreatefromwebp($file);
		break;

}

if($file_ext !== 'jpg') {
  //ブレンドモードを無効にする
  //完全なアルファチャネル情報を保存するフラグをonにする
  if($moto_w > $downsize_w) {
  imagealphablending($downsize_img, false);
  imagesavealpha($downsize_img, true);
  } else {
  imagealphablending($original_img, false);
  imagesavealpha($original_img, true);
  }
}

//ベース画像データに元画像データをリサイズして合成
if($moto_w > $downsize_w) {
imagecopyresampled($downsize_img, $moto_img, 0, 0, 0, 0, $downsize_w, $downsize_h, $original_w, $original_h);
} else {
imagecopyresampled($original_img, $moto_img, 0, 0, 0, 0, $original_w, $original_h, $original_w, $original_h);
}

//指定のフォーマットで画像を保存
  if($moto_w > $downsize_w) {
imagewebp($downsize_img, $masonry_dir . $thum_filename . '.webp');
  } else {
imagewebp($original_img, $masonry_dir . $thum_filename . '.webp');
  }

//画像データをメモリから削除
imagedestroy($moto_img);
  if($moto_w > $downsize_w) {
  imagedestroy($downsize_img);
  } else {
  imagedestroy($original_img);
  }
}

function h($s) {
  return htmlspecialchars($s, ENT_QUOTES, 'UTF-8');
}

function logout() {
// セッション変数を全て解除する
$_SESSION = array();

// セッションを切断するにはセッションクッキーも削除する。
// Note: セッション情報だけでなくセッションを破壊する。
if (ini_get("session.use_cookies")) {
    $params = session_get_cookie_params();
    setcookie(session_name(), '', time() - 42000,
        $params["path"], $params["domain"],
        $params["secure"], $params["httponly"]
    );
}

// 最終的に、セッションを破壊する
session_destroy();
  }

function recordAdd($unixtime, $caption){
  global $datafile;
$new_record = "\n" . $unixtime . "," . $caption; // 改行とカンマを付けて新しいレコードを作成
file_put_contents($datafile, $new_record, FILE_APPEND); // ファイルの末尾に追記
}

function recordDel($unixtime){
  global $datafile;
$new_data   = array();
$data = file($datafile, FILE_IGNORE_NEW_LINES); // ファイルの内容を配列として読み込み
$data = array_filter($data, "strlen"); // 空文字列を除外する
foreach ($data as $value){
    $array = explode(",", $value, 2);
    $key = array_shift($array); // 最初の要素をキーとして取り出す
    if ($key != $unixtime) {
    $string = $array[0]; // 文字列
    $new_data[$key] = $key . "," . $string; // 配列の要素を更新
    }
}
file_put_contents($datafile, implode("\n", $new_data)); // 配列を改行で結合してファイルに上書き
}

function captionEdit($unixtime, $edit_caption){
  global $datafile;
$data = file($datafile, FILE_IGNORE_NEW_LINES); // ファイルの内容を配列として読み込み
$data = array_filter($data, "strlen"); // 空文字列を除外する
foreach ($data as $value){
    $array = explode(",", $value, 2);
    $key = array_shift($array); // 最初の要素をキーとして取り出す
    $string = $array[0]; // 文字列
    $new_data[$key] = $key . "," . $string; // 配列の要素を更新
  if ($key == $unixtime) { // keyが検索したいkeyと一致したら
    $string = $edit_caption; // 文字列を編集
    $new_data[$key] = $key . "," . $string; // 配列の要素を更新
  }
}
file_put_contents($datafile, implode("\n", $new_data)); // 配列を改行で結合してファイルに上書き
}

function getCaption(){
  global $datafile;
  global $new_data;
$data = file($datafile, FILE_IGNORE_NEW_LINES); // ファイルの内容を配列として読み込み
$data = array_filter($data, "strlen"); // 空文字列を除外する
  foreach ($data as $value) { // 配列をループで処理
    $array = explode(",", $value, 2);
    $key = array_shift($array); // 最初の要素をキーとして取り出す
    $value = $array[0]; // 残りの要素は文字列
    $new_data[$key] = $value; // 新しい配列にキーと値を格納する
  }
}

function get_yuv_text_color( $colorcode ) {
	$rgb = array( 'r' => 255, 'g' => 255, 'b' => 255 );
	$lum = 128;	// 輝度信号 Y の白黒分岐点 (128 がジャスト真ん中)

	// カラーコードを RGB に分割する
	if( stripos( $colorcode, '#' ) !== false ) {
		$colorcode = str_replace( '#', '', $colorcode );

		if( ctype_xdigit( $colorcode ) && strlen( $colorcode ) >= 6 ) {
			$rgb['r'] = hexdec( substr( $colorcode, 0, 2 ) );
			$rgb['g'] = hexdec( substr( $colorcode, 2, 2 ) );
			$rgb['b'] = hexdec( substr( $colorcode, 4, 2 ) );
		}
	}

	// RGB から YUV の輝度信号に変換
	$yuv = 0.299 * $rgb['r'] + 0.587 * $rgb['g'] + 0.114 * $rgb['b'];

	return ( $yuv >= $lum ) ? '#000' : '#fff';
}

